=== doc/source/requirements.txt ===
alabaster==1.0.0
anyio==4.8.0
babel==2.17.0
breathe==4.36.0
build==1.2.2.post1
certifi==2025.1.31
charset-normalizer==3.4.1
click==8.1.8
colorama==0.4.6
docutils==0.21.2
h11==0.14.0
idna==3.10
imagesize==1.4.1
importlib_metadata==8.6.1
Jinja2==3.1.6
livereload @ https://github.com/lepture/python-livereload/archive/master.zip#sha256=95371213cf9107242808ea6e1353b524d7c38d96e299604e651e43271263352c
MarkupSafe==3.0.2
packaging==24.2
pip-tools==7.4.1
Pygments==2.19.1
pyparsing==3.2.1
pyproject_hooks==1.2.0
pytz==2025.1
requests==2.32.3
roman-numerals-py==3.1.0
setuptools==75.8.2
six==1.17.0
sniffio==1.3.1
snowballstemmer==2.2.0
Sphinx==8.2.3
sphinx-autobuild==2024.10.3
sphinx-rtd-theme==3.0.2
sphinxcontrib-applehelp==2.0.0
sphinxcontrib-devhelp==2.0.0
sphinxcontrib-htmlhelp==2.1.0
sphinxcontrib-jquery==4.1
sphinxcontrib-jsmath==1.0.1
sphinxcontrib-qthelp==2.0.0
sphinxcontrib-serializinghtml==2.0.0
starlette==0.46.0
tornado==6.4.2
urllib3==2.3.0
uvicorn==0.34.0
watchfiles==1.0.4
websockets==15.0
wheel==0.45.1
zipp==3.21.0
